
 ORG $6000
;;tfr d,x;r1,r2 r2=r1
;+$300- put sinus
;; LDD [MAXAD]
;;poke 65483,1:poke 65480,1 - 2nd page (bit0-7)*512=adress
;;poke 65481,1:poke 65482,1 - 1st page 65481-set bit 1, 65482-clear bit 2
;;65478-65491 - clear/set

; ??basic PMODE 4 256x192,6144 bytes - how to enable one?
; 65472=1,65475=1,65477,1
;color same

; basic PMODE 3 128x192,6144 bytes, 32 bytes per line,4 colors
;11=red
;10-blue
;01-yellow
;00-green
;65472=1,65475=1,65477,1
;
;colors
;65314=128+64+32+C (c=0 or c=8)

;by default Vram start from 1024
;$400+$1800=$1C00,$1C00/512=$0E=%1110
;values are:
;6543210
;0000010 = 2*512=$400

;65478/$FFC6, clear bit 0
;65479/$FFC7, set bit 0

;65480/$FFC8, clear bit 1
;65481/$FFC9, set bit 1

;65482/$FFCA, clear bit 2
;65483/$FFCB, set bit 2

;65484/$FFCC, clear bit 3
;65485/$FFCD, set bit 3

;65486/$FFCE, clear bit 4
;65487/$FFCF, set bit 4

;65488/$FFD0, clear bit 5
;65489/$FFD1, set bit 5

;65490/$FFD2, clear bit 6
;65491/$FFD3, set bit 6


 jsr clear_400
 jsr clear_1C00
;turn PMODE3
 lda #1
 sta 65472
 sta 65475
 sta 65477


 lda #128+64+32+0;+0 for pal 1(R-B-Y-G), +8 for pal 2
 sta 65314


;sinpos equ $300
; ldx #$00
; ldy #$3F
; ldd #$00
;; std v1
;
;sin_lp
; pshs d
; sta sinpos+64,x
; sta sinpos,y
;
; eora #$FF
; adda #1 ;inca
; sta sinpos+128,y
; sta sinpos+192,x
;
; ldd v1
; addd #4
; std v1
;
; puls d
; addd v1
;
; leay	-1,y
; leax	1,x
; cmpx #$40
; bne sin_lp


;  COUNTER=COUNTER+1
;    cc=cc+1
;    dd=dd+2
;    For Y=0 To 191
;      sv=s((y-counter)&255)*2
;      xx.b=s(255&(cc+y))+s(255&(dd+y))
;      xx=xx>>1
;  
;    x1.a=s((sv+counter)&255)+lCenterX
;    x2.a=s((sv+counter+64)&255)+lCenterX
;    x3.a=s((sv+counter+128)&255)+lCenterX
;    x4.a=s((sv+counter+192)&255)+lCenterX
;   
;
;    If X2>X1
;      ;LineXY(x1,y,x2,y,RGB(255,0,0));RGB(SLICE,SLICE*0.5,SLICE*0.2))
;      Plot(x1+xx,y,RGB(255,0,0))
;      Plot(x2+xx,y,RGB(192,0,0))
;    EndIf
;
;    If X3>X2
;        ;LineXY(x2,y,x3,y,RGB(0,255,0));(SLICE*0.5,SLICE*0.2,SLICE))
;        Plot (x2+xx,y,RGB(0,255,0))
;        Plot (x3+xx,y,RGB(0,192,0))
;    EndIf
;
;    If X4>X3
;        ;LineXY(x3,y,x4,y,RGB(0,0,255));SLICE*0.2,SLICE,SLICE*0.5))
;        Plot (xx+x3,y,RGB(0,0,255))
;        Plot (xx+x4,y,RGB(0,0,192))
;    EndIf
;
;    If X1>X4
;        ;LineXY(x4,y,x1,y,RGB(0,255,127));RGB(SLICE*0.2,SLICE*0.5,SLICE))
;        Plot (xx+x4,y,RGB(0,255,255))
;        Plot (xx+x1,y,RGB(0,192,192))
;    EndIf
;     
;    Next Y

;----------------------test output-------
;+2LUT - bitweight, +dispx
lut equ $6500
sin2 equ lut+512
 ldx #0
 ldd #$C000
blp
 pshs d
 lda sinpos,X
 sta sin2,X
 puls d
 stb lut,X ; bits
 sta lut+256,X ; disp X
 leax 1,X
 lsra
 lsra
 bne no_new1
 incb
 lda #$C0
no_new1
 cmpx #256
 bne blp

; ldd #lut+2
; std 182; 182=$65,183=$00
; lda [182];peek(183)+256*peek(182)
;-------------------------------------------------
	sta	$ffd7 ;?
vsync
	lda	$ff03
	bpl	vsync

 lda memv
 eora #$18
 sta memv
 cmpa #$04
 bne m1c00
;$400 - , ,  $1C00
 lda #1;-------set $0E=%1110,$400+$1800
 sta $FFC6;res_0
 sta $FFC9;set_1
 sta $FFCB;set_2
 sta $FFCD;set_3

 sta $FFCE;clear_b4
 sta $FFD0;clear_b5
 sta $FFD2;clear_b6
 
 jsr clear_400
 jmp runtw
m1c00
 lda #1 ;0010
 sta $FFC6;res_0
 sta $FFC9;set_1
 sta $FFCA;res_2
 sta $FFCC;res_3

 sta $FFCE;clear_b4
 sta $FFD0;clear_b5
 sta $FFD2;clear_b6

 jsr clear_1C00
;$1C00 - , ,  $400
;----------------------
runtw
 inc counter;  COUNTER=COUNTER+1
 inc vcc;    cc=cc+1
 inc vdd
 inc vdd;    dd=dd+2


;    For Y=0 To 191
 lda #$00
 sta ycn

 ldx memv
drlp
 stx v1
;      sv=s((y-counter)&255)*2
 clra
 ldb ycn
 subb counter
 tfr D,X;tfr r1,r2  r2=r1
 leax sinpos,X
 ldb ,X
; asrb ;>>1 ;?
;+ aslb
 stb sv

;      xx.b=s(255&(cc+y))+s(255&(dd+y))
;      xx=xx>>1
 clra
 ldb vcc
 addb ycn
 tfr D,Y
 ldb vdd
 addb ycn
 tfr D,X
 lda sinpos,X
 adda sinpos,Y
 sta xx

xc equ 64
;    x1.a=s((sv+counter)&255)+lCenterX
 clra
 ldb sv
 addb counter
 tfr D,X;tfr r1,r2  r2=r1
 leax sinpos,X
 lda ,X
 adda #xc
 sta x1

;    x2.a=s((sv+counter+64)&255)+lCenterX
 clra
 addb #$40
 tfr D,X;tfr r1,r2  r2=r1
 leax sinpos,X
 lda ,X
 adda #xc
 sta x2

;    x3.a=s((sv+counter+128)&255)+lCenterX
 clra
 addb #$40
 tfr D,X;tfr r1,r2  r2=r1 or abx?
 leax sinpos,X
 lda ,X
 adda #xc
 sta x3
;    x4.a=s((sv+counter+192)&255)+lCenterX
 clra
 addb #$40
 tfr D,X;tfr r1,r2  r2=r1
 leax sinpos,X
 lda ,X
 adda #xc
 sta x4


 lda #lut/256
 sta 182 ;[182]=adress


;    If X2>X1
;      LineXY(x1,y,x2,y,RGB(255,0,0));RGB(SLICE,SLICE*0.5,SLICE*0.2))
;      Plot(x1+xx,y,RGB(255,0,0))
;      Plot(x2+xx,y,RGB(192,0,0))
;    EndIf
 lda x2
 suba x1
 bcs cond2

 ldb x1
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182];+and mask for color
 anda #%10101010
 ora ,X
 sta ,X
 dec 182

 ldb x2
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182]
 ora ,X
 sta ,X
 dec 182


cond2
;    If X3>X2
;        ;LineXY(x2,y,x3,y,RGB(0,255,0));(SLICE*0.5,SLICE*0.2,SLICE))
;        Plot (x2+xx,y,RGB(0,255,0))
;        Plot (x3+xx,y,RGB(0,192,0))
;    EndIf
 lda x3
 suba x2
 bcs cond3

 ldb x3
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182];+and mask for color
 ora ,X
 sta ,X
 dec 182

 ldb x2
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182]
 ora ,X
 sta ,X
 dec 182


cond3
;    If X4>X3
;        ;LineXY(x3,y,x4,y,RGB(0,0,255));SLICE*0.2,SLICE,SLICE*0.5))
;        Plot (xx+x3,y,RGB(0,0,255))
;        Plot (xx+x4,y,RGB(0,0,192))
;    EndIf
 lda x4
 suba x3
 bcs cond4

 ldb x4
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182];+and mask for color
 ora ,X
 sta ,X
 dec 182

 ldb x3
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182]
 ora ,X
 sta ,X
 dec 182

cond4
;    If X1>X4
;        ;LineXY(x4,y,x1,y,RGB(0,255,127));RGB(SLICE*0.2,SLICE*0.5,SLICE))
;        Plot (xx+x4,y,RGB(0,255,255))
;        Plot (xx+x1,y,RGB(0,192,192))
;    EndIf
 lda x1
 suba x4
 bcs cond5

 ldb x1
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182

; ldb [182]
; eorb #$FF
; andb ,X
; stb , X
 lda [182];+and mask for color
 anda #%10101010
 ora ,X
 sta ,X
 dec 182

 ldb x4
 stb 183
 ldb [182]
 ldx v1
 abx
 inc 182
 
 lda [182]
 ora ,X
 sta ,X
 dec 182

cond5

;next line
 ldx v1
 leax 32,X ;X=X+32
; cmpy #$C0+sinpos
 inc ycn;dec ycn
 lda ycn
 cmpa #$C0-1
 beq enddraw
 jmp drlp
;----------------------------------------
enddraw
	sta	$ffd8

 jmp vsync
;----------------------------------------
clear_400
 ldx #$400
 bra cls
clear_1C00
 ldx #$1C00
cls
;	lda	$ff02
	sta	$ffd9
 ldd #0
 ldy #$C0;0C00/4
clp
 std ,X++
 std ,X++
 std ,X++
 std ,X++
 
 std ,X++
 std ,X++
 std ,X++
 std ,X++
 
 std ,X++
 std ,X++
 std ,X++
 std ,X++
 
 std ,X++
 std ,X++
 std ,X++
 std ,X++

 leay -1,y
 bne clp
	sta	$ffd8

 rts
;------------vars------------
memv fcb $1C,0

llen fcb 0
sv fcb 0
xx fcb 0
col1 fcb 0;real value color
col2 fcb 0;color value for shift

counter fcb 0
vcc fcb 0
vdd fcb 0

ycn fcb 0

x1 fcb 0
x2 fcb 0
x3 fcb 0
x4 fcb 0

v1 fcb 0,0

;binary is % or 0bXXXXXXXX
bity ; yellow
;AABBCCDD
 fcb %01000000 ; AA
 fcb %00010000 ; BB
 fcb %00000100 ; CC
 fcb %00000001 ; DD

bitr ; red
 fcb %11000000
 fcb %00110000
 fcb %00001100
 fcb %00000011

sinpos
 fcb $00,$00,$01,$02,$03,$03,$04,$05,$06,$07,$07,$08,$09,$0A,$0A,$0B
 fcb $0C,$0C,$0D,$0E,$0F,$0F,$10,$11,$11,$12,$13,$13,$14,$14,$15,$16
 fcb $16,$17,$17,$18,$18,$19,$19,$1A,$1A,$1B,$1B,$1B,$1C,$1C,$1C,$1D
 fcb $1D,$1D,$1E,$1E,$1E,$1E,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F
 fcb $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F,$1E,$1E,$1E,$1E,$1D
 fcb $1D,$1D,$1C,$1C,$1C,$1B,$1B,$1B,$1A,$1A,$19,$19,$18,$18,$17,$17
 fcb $16,$16,$15,$14,$14,$13,$13,$12,$11,$11,$10,$0F,$0F,$0E,$0D,$0C
 fcb $0C,$0B,$0A,$0A,$09,$08,$07,$07,$06,$05,$04,$03,$03,$02,$01,$00
 fcb $00,$00,$FF,$FE,$FD,$FD,$FC,$FB,$FA,$F9,$F9,$F8,$F7,$F6,$F6,$F5
 fcb $F4,$F4,$F3,$F2,$F1,$F1,$F0,$EF,$EF,$EE,$ED,$ED,$EC,$EC,$EB,$EA
 fcb $EA,$E9,$E9,$E8,$E8,$E7,$E7,$E6,$E6,$E5,$E5,$E5,$E4,$E4,$E4,$E3
 fcb $E3,$E3,$E2,$E2,$E2,$E2,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1
 fcb $E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E1,$E2,$E2,$E2,$E2,$E3
 fcb $E3,$E3,$E4,$E4,$E4,$E5,$E5,$E5,$E6,$E6,$E7,$E7,$E8,$E8,$E9,$E9
 fcb $EA,$EA,$EB,$EC,$EC,$ED,$ED,$EE,$EF,$EF,$F0,$F1,$F1,$F2,$F3,$F4
 fcb $F4,$F5,$F6,$F6,$F7,$F8,$F9,$F9,$FA,$FB,$FC,$FD,$FD,$FE,$FF,$00
 